## punycode punycode |

## Functions

const char * | punycode_strerror ()
int | punycode_encode ()
int | punycode_decode ()

## Types and Values

#define | IDNAPI
enum | Punycode_status
typedef | punycode_uint

## Description

## Functions

### punycode_strerror ()

    const char *
    punycode_strerror (Punycode_status rc);

Convert a return code integer to a text string. This string can be used to output a diagnostic message to the user.

PUNYCODE_SUCCESS: Successful operation. This value is guaranteed to always be zero, the remaining ones are only guaranteed to hold non-zero values, for logical comparison purposes. PUNYCODE_BAD_INPUT: Input is invalid. PUNYCODE_BIG_OUTPUT: Output would exceed the space provided. PUNYCODE_OVERFLOW: Input needs wider integers to process.

#### Parameters

rc | an Punycode_status return code. |

#### Returns

Returns a pointer to a statically allocated string containing a description of the error with the return code `rc` .

### punycode_encode ()

    int
    punycode_encode (size_t input_length,
                     const punycode_uint input[],
                     const unsigned char case_flags[],
                     size_t *output_length,
                     char output[]);

Converts a sequence of code points (presumed to be Unicode code points) to Punycode.

#### Parameters

input_length | The number of code points in the `input` array and the number of flags in the `case_flags` array. |
input | An array of code points. They are presumed to be Unicode code points, but that is not strictly REQUIRED. The array contains code points, not code units. UTF-16 uses code units D800 through DFFF to refer to code points 10000..10FFFF. The code points D800..DFFF do not occur in any valid Unicode string. The code points that can occur in Unicode strings (0..D7FF and E000..10FFFF) are also called Unicode scalar values. |
case_flags | A `NULL` pointer or an array of boolean values parallel to the `input` array. Nonzero (true, flagged) suggests that the corresponding Unicode character be forced to uppercase after being decoded (if possible), and zero (false, unflagged) suggests that it be forced to lowercase (if possible). ASCII code points (0..7F) are encoded literally, except that ASCII letters are forced to uppercase or lowercase according to the corresponding case flags. If `case_flags` is a `NULL` pointer then ASCII letters are left as they are, and other code points are treated as unflagged. |
output_length | The caller passes in the maximum number of ASCII code points that it can receive. On successful return it will contain the number of ASCII code points actually output. |
output | An array of ASCII code points. It is *not* null-terminated; it will contain zeros if and only if the `input` contains zeros. (Of course the caller can leave room for a terminator and add one if needed.) |

#### Returns

The return value can be any of the Punycode_status values defined above except `PUNYCODE_BAD_INPUT`. If not `PUNYCODE_SUCCESS`, then `output_size` and `output` might contain garbage.

### punycode_decode ()

    int
    punycode_decode (size_t input_length,
                     const char input[],
                     size_t *output_length,
                     punycode_uint output[],
                     unsigned char case_flags[]);

Converts Punycode to a sequence of code points (presumed to be Unicode code points).

#### Parameters

input_length | The number of ASCII code points in the `input` array. |
input | An array of ASCII code points (0..7F). |
output_length | The caller passes in the maximum number of code points that it can receive into the `output` array (which is also the maximum number of flags that it can receive into the `case_flags` array, if `case_flags` is not a `NULL` pointer). On successful return it will contain the number of code points actually output (which is also the number of flags actually output, if case_flags is not a null pointer). The decoder will never need to output more code points than the number of ASCII code points in the input, because of the way the encoding is defined. The number of code points output cannot exceed the maximum possible value of a punycode_uint, even if the supplied `output_length` is greater than that. |
output | An array of code points like the input argument of `punycode_encode()` (see above). |
case_flags | A `NULL` pointer (if the flags are not needed by the caller) or an array of boolean values parallel to the `output` array. Nonzero (true, flagged) suggests that the corresponding Unicode character be forced to uppercase by the caller (if possible), and zero (false, unflagged) suggests that it be forced to lowercase (if possible). ASCII code points (0..7F) are output already in the proper case, but their flags will be set appropriately so that applying the flags would be harmless. |

#### Returns

The return value can be any of the Punycode_status values defined above. If not `PUNYCODE_SUCCESS`, then `output_length` , `output` , and `case_flags` might contain garbage.

## Types and Values

### IDNAPI

    #define             IDNAPI

### enum Punycode_status

Enumerated return codes of `punycode_encode()` and `punycode_decode()`. The value 0 is guaranteed to always correspond to success.

#### Members

PUNYCODE_SUCCESS | Successful operation. This value is guaranteed to always be zero, the remaining ones are only guaranteed to hold non-zero values, for logical comparison purposes. |
PUNYCODE_BAD_INPUT | Input is invalid. |
PUNYCODE_BIG_OUTPUT | Output would exceed the space provided. |
PUNYCODE_OVERFLOW | Input needs wider integers to process. |

### punycode_uint

      typedef uint32_t punycode_uint;

Unicode code point data type, this is always a 32 bit unsigned integer.